# API

## Requêtes

| Action                                | Requête               | 
| ------------------------------------- | --------------------- | 
| Créer un utilisateur                  | POST / user           | 
| Récupérer tous les utilisateurs       | GET / user            | 
| Récupérer un utilisateur              | GET / user / {id}     | 
| Modifier les données d'un utilisateur | PUT / user / {id}     | 
| Supprimer un utilisateur              | DELETE / user / {id}  | 
| Obtenir un token                      | POST / login          | 
| Vérifier la validité d'un token       | GET / validatetoken   |

### Format des données envoyées à l'api
JSON :

````json
    {
        "key": "value"
    }
````

### Créer ou modifier un utilisateur
````json
    {
        "firstname": "string",
        "lastname": "string",
        "login": "string",
        "email": "string",
        "password": "bcrypt",
        "role": "int"
    }
````

### Obtenir un token
````json
    {
        "login": "string",
        "password": "bcrypt"
    }
````

### Vérifier un token
````php
    header('Authorization: Bearer ' . token)
````

## Pour utiliser l'api
- Ajouter la base de donnée chez vous grâce à BackEnd/api/sql/createBD.sql
- Modifier BackEnd/api/config/config.php:3-7
    ````php
        define('DB_HOST', 'localhost');
        define('DB_PORT', 8888);
        define('DB_DATABASE', 'dbtest');
        define('DB_USERNAME', 'root');
        define('DB_PASSWORD', 'root');
    ````